# -*- coding: utf-8 -*-
from setuphelpers import *
import time

uninstallkey = []
terminator_path = makepath(programfiles,'Terminator')
terminator_ico = 'terminator.ico'
launch_script = 'start_terminator.vbs'
wscript = makepath(system32(),'wscript.exe')
arg = makepath(terminator_path,launch_script)
icon = makepath(terminator_path,terminator_ico)

def install():
    print('installing %s' % control.asrequirement())
    mkdirs(terminator_path)
    filecopyto(launch_script,terminator_path)
    filecopyto(terminator_ico,terminator_path)

def session_setup():
    import win32ui
    import win32con
    import time
    installterminator = str(registry_readstring(HKEY_CURRENT_USER, "SOFTWARE\\wapt\\Terminator\\",'Install'))
    firstinstall = False

    if installterminator == '' :

        rc = win32ui.MessageBox('Souhaitez vous installer terminator sur votre profil ?', "Configuration de terminator", 4100)
        if rc == 6 :
            registry_setstring(HKEY_CURRENT_USER, "SOFTWARE\\wapt\\Terminator\\",'Install','yes', type=REG_SZ)
            run('start "" "%s" "exit"'  % makepath(user_local_appdata,'Microsoft','WindowsApps','debian.exe'),timeout=120)
            nbtest = 0
            while isrunning('debian.exe'):
                time.sleep(1)
                print('Debian.exe is running')
                nbtest = nbtest + 1
                if nbtest > 120 :
                    killalltasks('debian.exe')
            firstinstall = True
        else:
            registry_setstring(HKEY_CURRENT_USER, "SOFTWARE\\wapt\\Terminator\\",'Install','no', type=REG_SZ)

    installterminator = str(registry_readstring(HKEY_CURRENT_USER, "SOFTWARE\\wapt\\Terminator\\",'Install'))

    if installterminator == 'yes' :
        print('## Set default bash user as root to perform install')
        run('"%s" config --default-user root' % makepath(user_local_appdata,'Microsoft','WindowsApps','debian.exe'))
        print('## Install Terminator and Dbus-x11')
        run('start bash.exe -c -l "apt-get update"')
        time.sleep(10)
        run('start bash.exe -c -l "apt-get install dbus-x11 terminator -y"')
        print('## Restore current user as default bash user')
        run_notfatal('"%s" config --default-user %s' % (makepath(user_local_appdata,'Microsoft','WindowsApps','debian.exe'),get_current_user().lower()))
        start_menu_path = makepath(winshell.programs(0),'StartUp')
        create_shortcut(makepath(start_menu_path,'vcxsrv.lnk'),installed_softwares('VcXsrv')[0]['uninstall_string'].replace('uninstall.exe','vcxsrv.exe').split('"')[1],r':0 -ac -terminate -lesspointer -multiwindow -clipboard -wgl -dpi auto')
        create_user_desktop_shortcut('Terminator',wscript,'"%s"' % arg,r'%USERPROFILE%',icon)
        if not isrunning('vcxsrv.exe'):
            run('start "" "%s" :0 -ac -terminate -lesspointer -multiwindow -clipboard -wgl -dpi auto' % installed_softwares('VcXsrv')[0]['uninstall_string'].replace('uninstall.exe','vcxsrv.exe').split('"')[1],timeout=120)
    if firstinstall:
        resultask = win32ui.MessageBox(u"Installation de terminator terminée, l'icône est disponible sur le bureau", 'Terminator',4096)



def uninstall():
    print('uninstalling %s' % control.asrequirement())
    remove_desktop_shortcut('Terminator')
    remove_tree(terminator_path)



